SyntaxElementMorph subclass: #BlockElementMorph
	instanceVariableNames: 'palette steps '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 23:56'!
addStep: aStepElement
	steps contents isNil 
		ifTrue: [steps contents: aStepElement]
		ifFalse: [steps contents addToLast: aStepElement]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2009 23:35'!
addVarNames: aCollection
	palette addVarNames: aCollection
! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:00'!
addVariable
	|ans|

	ans _ FillInTheBlank request: 'add variable:'.
	(ans size > 0) ifTrue: [self addVarNames: (Array with: (SyntaxElementMorph objectNameFrom: ans))]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 18:34'!
addVariableNamed: aSymbol
	palette addVariableNamed: aSymbol! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 00:04'!
addVariables
	|ans|

	ans _ FillInTheBlank request: 'add variables:'.
	(ans size > 0) ifTrue: [self addVarNames: (ans findTokens: ' ')]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 07:32'!
allVariableNames
	^self variableNames! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:33'!
asSmalltalk
	| ws vn|
	ws _ WriteStream on: String new.
	ws nextPut: $[.
	(vn _ self variableNames) isEmpty ifFalse: [
		vn do: [:n|
			ws nextPut: $:.
			ws nextPutString: n, ' ' ].
		ws nextPutString: '| '].
	ws nextPutString: steps asSmalltalk, ']'.
	^ws contents! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:01'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	m add: 'add variable...' action: #addVariable.
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.
	m add: 'show result...' action: #showResult.
	m add: 'evaluate' action: #evaluate.
	^m! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 02:41'!
evaluate
	^Compiler evaluate: self asSmalltalk, ' value'! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:17'!
fit
	| bw bw2 cw handle x y|
	bw _ self borderWidth.
	bw2 _ bw * 2.
	cw _ self labelFont widthOf: $ .
	handle _ cw * 2.

	palette position: (self left + handle) @ (self top).
	(palette height = 0)
		ifTrue: [y _ self top + (bw * 3)]
		ifFalse: [y _ palette bottom].
	

	steps position: (self left + bw2 + handle) @ y.

	x _ (steps right + bw2) max: palette right.

	self width: x - self left.
	(palette height = 0)
		ifTrue: [ self height: steps height + (self borderWidth * 5) ]
		ifFalse: [self height: steps height + palette height + (bw2) ].

	self refreshVarColors.

	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:19'!
initialize
	super initialize.
	color _ Color paleBlue darker.
	palette _ PaletteElementMorph new.
	self addMorph: palette.
	steps _ StepHolderElementMorph new.
	steps color: color slightlyDarker.
	self addMorph: steps.
	self fit.! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:41'!
refreshVarColors

	self allMorphsDo: [:m|
		((m isMemberOf: ObjectElementMorph) and: [
			self allVariableNames includes: m name]) ifTrue: [
				m color: self varColor ]]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 00:18'!
rootForGrabOf: aMorph
	"Allow myself to be extracted."

	(self ownerThatIsA: ElementPaletteMorph) ifNotNil: [
		(self ownerThatIsA: MessageElementMorph)
			ifNotNil: [^owner rootForGrabOf: owner ]].
	^super rootForGrabOf: aMorph! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 02:24'!
steps
	^steps contents! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 23:58'!
varColor
	^palette varColor! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:05'!
variableNames
	^palette variableNames! !
