MultilineStringMorph subclass: #ListMultilineStringMorph
	instanceVariableNames: 'deleteMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-UI-Watchers'!

!ListMultilineStringMorph methodsFor: 'initialization' stamp: 'ee 2/3/2009 13:24'!
initialize

	super initialize.
	deleteMorph _ (ImageMorph new form: (ScratchFrameMorph skinAt: #deleteItem)).
! !


!ListMultilineStringMorph methodsFor: 'event handling' stamp: 'ee 2/1/2009 12:59'!
handlesMouseOver: evt

	^ true
! !

!ListMultilineStringMorph methodsFor: 'event handling' stamp: 'jens 7/15/2010 22:41'!
keyStroke: evt

	| ch ownerList newCell oldH |
	ch _ evt keyValue.
	ownerList _ self ownerThatIsA: ScratchListMorph.

	"insert list item with cr"
	(ch = 3) & (evt buttons = 0) ifTrue: [ch _ 13].	"map enter key to cr"
	(ch = 13) ifTrue: [
		ownerList ifNotNil:[
			newCell _ ownerList insertLine: '' at: ownerList focusIndex + 1. 
			ownerList focusCell: newCell].
		^ self].

	"skip to previous list item with tab or down arrow"
	(ch = 30) ifTrue: [
		ownerList ifNotNil:[
			ownerList focusIndex: ownerList focusIndex - 1].
		^ self].

	"skip to next list item with tab or down arrow"
	(ch = 9) | (ch = 31) ifTrue: [
		ownerList ifNotNil:[
			ownerList focusIndex: ownerList focusIndex + 1].
		^ self].

	oldH _ self height.
	super keyStroke: evt.
	(ownerList notNil and: [self height ~= oldH]) ifTrue: [
		ownerList extent: ownerList extent].  "force re-layout"
	self fixLayout.
! !

!ListMultilineStringMorph methodsFor: 'event handling' stamp: 'ee 2/12/2009 15:09'!
keyboardFocusChange: aBoolean

	super keyboardFocusChange: aBoolean.
	hasFocus
		ifTrue: [
			self textColor: (Color gray: 0.15).
			self owner color: (ScriptableScratchMorph listBlockColor mixed: 0.4 with: Color white).
			self addMorphBack: deleteMorph.
			self fixLayout]
		ifFalse: [
			self textColor: Color white.
			self owner color: ScriptableScratchMorph listBlockColor.
			deleteMorph delete].
! !

!ListMultilineStringMorph methodsFor: 'event handling' stamp: 'jens 4/19/2010 02:40'!
mouseDown: evt

	| list p ownerList i |

	self isInWorld ifFalse: [^ self].  "not editable in presentation mode"
	self isList ifTrue: [^ self list mouseDown: evt].
	super mouseDown: evt.
	p _ evt cursorPoint.

	(list _ self ownerThatIsA: ScratchListMorph)
		ifNotNil: [list focusCell: owner].

	ownerList _ self ownerThatIsA: ScratchListMorph.
	((deleteMorph bounds expandBy: 4) containsPoint: p) ifTrue: [
		(ownerList notNil) ifTrue: [
			i _ ownerList indexOfCell: self owner. 
			ownerList deleteLineAt: i.
			(ownerList listContents size > (i - 1))
				ifTrue: [ownerList focusIndex: i]
				ifFalse: [ownerList focusIndex: i - 1]]].
! !


!ListMultilineStringMorph methodsFor: 'geometry' stamp: 'ee 5/14/2009 13:51'!
extent: aPoint

	super extent: aPoint.
	self fixLayout.
! !


!ListMultilineStringMorph methodsFor: 'private' stamp: 'jens 1/20/2011 00:06'!
fixLayout

	| readout |
	readout _ self ownerThatIsA: WatcherReadoutFrameMorph.
	readout ifNotNil: [
		(readout complexObject isKindOf: BYOBList) ifTrue: [^self].
		(readout complexObject isKindOf: ScratchListMorph) ifTrue: [^self].
		(readout complexObject isKindOf: ScriptableScratchMorph) ifTrue: [^self].
		deleteMorph position: (readout bottomRight) - (deleteMorph extent) - (3@5)]! !


!ListMultilineStringMorph methodsFor: 'byob' stamp: 'jens 7/16/2010 01:45'!
drawTextOn: aCanvas

	|rf|
	rf _ self ownerThatIsA: WatcherReadoutFrameMorph.
	rf ifNotNil: [((rf complexObject isKindOf: Morph) or: [rf complexObject isKindOf: BYOBList])
		ifTrue: [^ self ]].

	super drawTextOn: aCanvas! !

!ListMultilineStringMorph methodsFor: 'byob' stamp: 'jens 7/16/2010 01:11'!
isList

	|rf|
	rf _ self ownerThatIsA: WatcherReadoutFrameMorph.
	rf ifNotNil: [^ ((rf complexObject isKindOf: ScratchListMorph) or: [
		rf complexObject isKindOf: BYOBList])].
	^ false
! !

!ListMultilineStringMorph methodsFor: 'byob' stamp: 'jens 7/16/2010 01:27'!
list

	|rf|
	rf _ self ownerThatIsA: WatcherReadoutFrameMorph.
	rf ifNotNil: [((rf complexObject isKindOf: ScratchListMorph) or: [
		rf complexObject isKindOf: BYOBList])
			ifTrue: [ (rf complexObject isKindOf: BYOBList)
				ifTrue: [^ rf submorphs detect: [:sm | sm isKindOf: BYOBListWatcherMorph] ifNone: [nil]]
				ifFalse: [^ rf complexObject]]].
	^ nil
! !
