CommandBlockMorph subclass: #MultiArgCommandBlockMorph
	instanceVariableNames: 'addElementMorph removeElementMorph minArgs maxArgs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:49'!
addItem
	self stop.
	self commandSpec: commandSpec, ' %s'.


! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 22:21'!
addLabel

	super addLabel.
	removeElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90).
	argMorphs size > self minArgs ifTrue: [
		self addMorphBack: removeElementMorph].	
	addElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90).

	(selector = #doMakeNewList or: [
		((selector notNil and: [selector endsWith: 'List']) not
			and: [ maxArgs isNil or: [argMorphs size < maxArgs]])]) 
				ifTrue: [ self addMorphBack: addElementMorph].

	self adjustInternals! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 23:19'!
adjustInputParadigm: choice
	"private"

	| newSpec |

	(#(doRunBlockWithArgs doRunBlockWithArgList doForkBlockWithArgs doForkBlockWithArgList doCallBlockWithArgs doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	'with inputs' localized = choice ifTrue: [ 
		(selector endsWith: 'List') ifTrue: [
			selector _ ((selector copyFrom: 1 to: selector size - 'List' size), 's') asSymbol]].
	'with input list' localized = choice ifTrue: [
		(selector endsWith: 'List') ifFalse: [
			selector _ ((selector copyFrom: 1 to: selector size - 1), 'List') asSymbol ]].
	(selector endsWith: 'List') 
		ifTrue: [maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec localized asMacRoman. 
	self commandSpec: newSpec.





! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/16/2010 23:43'!
adjustInternals
	"private"

	| newSelector sdict newSpec |
	(#(		
			doRun
			doRunBlockWithArgs 
			doRunBlockWithArgList 
			doFork doForkBlockWithArgs 
			doForkBlockWithArgList 
			doReport 
			doCallBlockWithArgs 
			doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	sdict _ Dictionary new.
	argMorphs size = 2  ifTrue: [ 
		((selector endsWith: 'Args') |  (selector endsWith: 'List')) not 
			ifTrue: [
				sdict
					at: #doRun put: #doRunBlockWithArgs;
					at: #doFork put: #doForkBlockWithArgs;
					at: #doReport put: #doCallBlockWithArgs;
					yourself]
			ifFalse: [
				sdict
					at: #doRunBlockWithArgs put: #doRun;
					at: #doRunBlockWithArgList put: #doRun;
					at: #doForkBlockWithArgs put: #doFork;
					at: #doForkBlockWithArgList put: #doFork;
					at: #doCallBlockWithArgs put: #doReport;
					at: #doCallBlockWithArgList put: #doReport;
					yourself]].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [ selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.
	(selector endsWith: 'List') 
		ifTrue: [ maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.
	self commandSpec: newSpec.
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 01:12'!
argumentAt: index
	"Returns the argument morph at the given index."

	^argMorphs at: index.	"BYOB custom blocks don't need argPermutations"

! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/15/2010 23:43'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg val eval |
	
	blockTuple _ Array new: argMorphs size + 3.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	1 to: argMorphs size do: [:i |
		arg _ argMorphs at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
				ifTrue: [blockTuple at: i + 3 put: arg asBlockTuple]
				ifFalse: [(arg isKindOf: ExpressionArgMorph)
					ifTrue: [
						val _ arg getExpression.
						arg isNumberExpression
							ifTrue: [val = ' ' asUTF8
								ifTrue: [eval _ val]
								ifFalse: [eval _ val asNumberNoError]]
							ifFalse: [eval _ arg evaluate]]
					ifFalse: [eval _ arg evaluate].
					blockTuple at: i + 3 put: eval]]
			ifFalse: [blockTuple at: i + 3 put: arg asBlockTuple]].
	^ blockTuple
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'CWB 7/19/2011 07:12'!
fixBlockLayoutWrap
	"Update the positions of my submorphs."

	| parts lines line h x y minXForArgs nextB w space left maxX maxHeight mh |

	blockLayoutNeeded ifFalse: [^ self].

	cachedForm _ nil.
	cachedFeedbackForm _ nil.

	parts _ self nonControlFlowSubmorphs.
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left + 5.
	left _ x.
	maxX _ x.
	minXForArgs _ self left.
	space _ 4.

	parts do: [:m |
	((m isKindOf: CArgSlotMorph) or: [(m isKindOf: CReporterSlotMorph) or: [(m isKindOf: MultiArgMorph) and: [m isWrapping]]])
		ifTrue: [ 
			line isEmpty ifFalse: [
				lines add: line].
			m left: "self" left.
			lines add: (OrderedCollection with: m).
			(m isKindOf: MultiArgMorph)
				ifTrue: [m fixArgLayout]
				ifFalse: [m fixBlockLayout].
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
				ifTrue: [m width: 40].
			line _ OrderedCollection new.
			maxX _ maxX max: left + m width.
			x _ left ]
		ifFalse: [
			(x - left > self wrapWidth and: [m ~~ parts last]) ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].
			(m isKindOf: StringMorph)
				ifTrue: [m color: self labelColor]
				ifFalse: [x _ x max: minXForArgs].

			m left: x.
			(m fullBounds right - left > 400 and: [line isEmpty not and: [m ~~ parts last]])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
			maxX _ maxX max: x]].
	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 37.

	"distribute lines vertically"

	space _ 2.
	y _ self top + 2 "4" "space".
	lines do: [:eachLine |
		maxHeight _ 14.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate 
			or: [((m isKindOf: CArgSlotMorph) or: [m isKindOf: OSlotMorph]) and: [m isEmptySlot not]] ])
				ifTrue: [mh _ m height + 5]
				ifFalse: [mh _ m height].
			maxHeight _ mh max: maxHeight.
			(m isKindOf: CArgSlotMorph) ifTrue: [
				maxHeight _ m height - 4]].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2) + 1].
		y _ y + maxHeight + space].

	"adjust CArgSlots"

	parts do: [:m |
		((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
			ifTrue: [m width: w - 5]].

	self isStop
		ifTrue: [h _ y - self top + space]
		ifFalse: [h _ y - self top + space + 4.].

	(parts last isKindOf: CArgSlotMorph) ifTrue: [
		h _ h + space + 5].
	
	self extent: w @ h.

	"adjust Multi-CArgSlots"

	parts do: [:m | (m isKindOf: MultiArgMorph)
		ifTrue: [m loopsWidth: w - 5]].

	(nextB _ self nextBlock) ifNotNil: [
		nextB position: self left@(self bottom - 4).
		nextB fixBlockLayout].
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 23:59'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	selector ifNil: [^nil].
	(selector beginsWith: 'doRun')
		ifTrue: [^'doRun'].
	(selector beginsWith: 'doFork')
		ifTrue: [^'doFork'].
	^super helpScreenName
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 23:39'!
maxArgs
	^ maxArgs! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 23:39'!
maxArgs: anInteger
	maxArgs _ anInteger! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 00:38'!
minArgs
	^minArgs ifNil: [minArgs _ 0]! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/1/2009 13:01'!
minArgs: anInteger
	minArgs _ anInteger! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 00:38'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(addElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self addItem ].
		(removeElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self removeItem ]].
	^super mouseDown: evt! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:49'!
removeItem
	self stop.
	argMorphs size > self minArgs ifTrue: [
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ].
! !
