NXTSensor subclass: #NXTCompassSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!
!NXTCompassSensor commentStamp: '<historical>' prior: 0!
This allows you to work with a HiTechnic or Mindstorms compass sensor with the NXT.!


!NXTCompassSensor methodsFor: 'object i/o' stamp: 'CWB 6/1/2011 23:06'!
initFieldsFrom: anObjStream version: classVersion

	"We had to change from a generic compass sensor to a specific one.
	If loading old code, choose a reasonable default".

	super initFieldsFrom: anObjStream version: classVersion.

	(concreteType = 'Compass Sensor') ifTrue: [
		concreteType _ 'HiTechnic Compass Sensor'.
	].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTCompassSensor class
	instanceVariableNames: ''!

!NXTCompassSensor class methodsFor: 'accessing' stamp: 'CWB 12/29/2010 15:29'!
baseName

	^ 'compass sensor'! !

!NXTCompassSensor class methodsFor: 'accessing' stamp: 'CWB 6/1/2011 22:52'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."


	^ #(
		'HiTechnic Compass Sensor'
		'Mindsensors Compass Sensor'
	).! !


!NXTCompassSensor class methodsFor: 'block specs' stamp: 'CWB 12/29/2010 15:33'!
configBlockSpec

	^ 'Measures heading using a %p named %s'.! !

!NXTCompassSensor class methodsFor: 'block specs' stamp: 'CWB 1/19/2013 20:31'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks.  Note that the 'selectors' are all unique, start with the class name followed by a colon, but do not actually have functions that go with them."

	| blocks |
	
	blocks _ #(
		'sensing'
			('%P heading' 					r	NXTCompassSensor:heading:)
			('start calibrating %P' 			-	NXTCompassSensor:startcalibrating:)
			('stop calibrating %P' 			-	NXTCompassSensor:stopcalibrating:)
		).

	^ blocks  ! !


!NXTCompassSensor class methodsFor: 'dropdown lists' stamp: 'CWB 12/29/2010 15:40'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"Things that can be read from the sensor or its settings"
		^ #('start' 'stop').
	].

	^ nil.! !
