EventHatMorph subclass: #MouseClickEventHatMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
!MouseClickEventHatMorph commentStamp: '<historical>' prior: 0!
I am a hat block for stacks triggered by clicking on an object with the mouse.
!


!MouseClickEventHatMorph methodsFor: 'initialization' stamp: 'nb 1/15/2008 21:08'!
initialize

	| parts s |
	super initialize.
	self removeAllMorphs.

	parts _ ScratchTranslator labelPartsFor: 'when %m clicked'.

	s _ StringMorph new contents: parts first; font: (ScratchFrameMorph getFont: #Label); color: Color white.
	self addMorphBack: s.

	self addMorphBack:
		(UpdatingStringMorph new useStringFormat
			font: (ScratchFrameMorph getFont: #Label);
			color: Color white;
			target: self;
			getSelector: #receiverName).

	s _ s fullCopy contents: parts second.
	self addMorphBack: s.
! !


!MouseClickEventHatMorph methodsFor: 'other' stamp: 'CWB 8/5/2010 21:22'!
englishCodeSpec
	"Returns the original code specification that created this block"

	^ 'when %m clicked'

! !

!MouseClickEventHatMorph methodsFor: 'other' stamp: 'jm 3/28/2005 12:38'!
eventName

	^ 'Scratch-MouseClickEvent'
! !

!MouseClickEventHatMorph methodsFor: 'other' stamp: 'jm 12/8/2005 19:22'!
printHatNameOn: aStream
	"Append a human-readable string for this hat block's name to the given stream."

	aStream nextPutAll: 'when ', self receiverName, ' clicked'; cr.
! !

!MouseClickEventHatMorph methodsFor: 'other' stamp: 'jm 12/17/2004 16:04'!
receiverName

	(scriptOwner respondsTo: #objName)
		ifTrue: [^ scriptOwner objName]
		ifFalse: [^ 'I''m'].
! !
