#!/bin/bash

# This tool, designed to work on a unix system, will zip up the latest image file,
# upload it, and then set a symlink to it on the remote directory.
#
# If you have the necessary passwords, please run it from the main Enchanting directory.

FILENAME="Enchanting-Image-`date +%Y-%m-%d_%H%M`.zip"

echo "Compressing Enchanting.image."
zip -9 $FILENAME Enchanting.image Enchanting.changes
echo

echo "Uploading compressed file."
scp -p $FILENAME robotclub.ab.ca:subdomains/static/source_code/enchanting/
echo

echo "Updating symlink for Enchanting-Image-Latest.zip."
ssh robotclub.ab.ca "cd subdomains/static/source_code/enchanting && ln -fs $FILENAME Enchanting-Image-Latest.zip"
echo

echo "Cleaning Up"
rm $FILENAME

echo "Done."
