@ECHO OFF

REM  This script (re)builds the backend, saves a copy of front-end files and
REM  imports the latest source into the front end, and saves the image in user mode
REM 
REM  Pass in:
REM     setVersion 0.0.3
REM  to your command line if you'd like to set the version number.

PUSHD .

REM be sure we are in the batch file's directory
CD %0\..\
CD BackEnd
ECHO REBUILDING BACKEND
DEL *.class
CALL build.bat
CD ..

ECHO REBUILDING ON-DEVICE LIBRARY
CALL OnDevice\NXT\build-enchanting-jar.bat

ECHO REBUILDING FRONTEND
REM  Backup the FrontEnd and copy over BaseEnchanting to create a new image
CD FrontEnd

FOR /F "skip=1 tokens=1-6" %%A IN ('WMIC Path Win32_LocalTime Get Day^,Hour^,Minute^,Month^,Second^,Year /Format:table') DO (
    SET /A TODAY=%%F*10000+%%D*100+%%A
    SET /A CLOCK=%%B*10000+%%C*100+%%E
    SET NOW=%TODAY:~0,4%-%TODAY:~4,2%-%TODAY:~6,2%_%CLOCK%
 )

IF EXIST Enchanting.image   RENAME Enchanting.image Enchanting-%NOW%.image
IF EXIST Enchanting.changes RENAME Enchanting.changes Enchanting-%NOW%.changes 

COPY BaseEnchanting.image Enchanting.image
COPY BaseEnchanting.changes Enchanting.changes

REM  And not build the front end
CD ..
CALL verbose_enchanting.windows.bat %* importSource saveImageInUserMode

POPD


